BEGIN { 

  /*****************************************************************/
  /* This AWK script is to format a DOT file in a style that can   */
  /* be translated into FC2 file.  The style is that all the edges */
  /* starting with a node are all put under the node definition.   */
  /*****************************************************************/

  rem = 0 ; 
  lineno = 0 ;
  vno = 0 ;
  eno = 0 ;
}
/\/\*.*\*\// { next ; }
/\/\*.*/ { rem = 1 ; next ; } 
/.*\*\// { rem = 0 ; next ; }
/./ { if ( rem == 1) 
         next ; 
}
/digraph/ {
  print ;
}
/\->/ {
  edgeline[eno] = $0 ;
  eno++ ;
}

/"[0-9a-zA-Z\.\-]+" *\[ *shape *= *ellipse/ {
    nodename = substr($0,match($0,/"[0-9a-zA-Z\.\-]+"/), RLENGTH);
    nodestr[vno] = nodename ;
    nodeline[vno] = $0 ;
    edgeno[vno] = 0 ;
    hash[nodename] = vno ;
    vno ++ ;
}
/"[0-9a-zA-Z\.\-]+" *\[ *shape *= *box/ {
    nodename = substr($0,match($0,/"[0-9a-zA-Z\.\-]+"/), RLENGTH);
    nodestr[vno] = nodename ;
    nodeline[vno] = $0 ;
    edgeno[vno] = 0 ;
    hash[nodename] = vno ;
    start = vno ;
    vno ++ ;
}
END {
    for (i=0;i< vno; i++) {
        print nodeline[i] ;
        for (j=0;j < eno; j++) {
          from = substr(edgeline[j], match(edgeline[j],/"[0-9a-zA-Z\.\-]+"/), RLENGTH) ;

          if (from == nodestr[i])
              print edgeline[j];
        }      

     }

     print "};" ;

}

    
      
	

