#-------------------------------------------------------
# collectport
# 
# This program is used to collect all the port name, index
# from an fc2 file and APPEND to an outfile (ofile)
# This program is called by
#
#     gawk -f collectport.awk -v ofile=data foo.fc2
#
#-------------------------------------------------------
BEGIN {
  structcoming = 0 ;
}
/nets/ { 
  if ($2 != 1) {
#  this is a net file
    print "ERROR: file " FILENAME " is a fc2 net file! " ;
    print "       please delete and run your program again " ;
    exit 1;
  }
}
  
/struct/ {
       netname = substr($0, match($0,/"[a-zA-Z0-9_]+"/), RLENGTH);
       purenetname = substr(netname,2,RLENGTH-2);
       print "NET " purenetname >> ofile ;
       eno = 0 ;
}
/S1/ {
# this format happens wen fc2 file is generated from fc2explicit
  structcoming = 1 ;
}
/:[0-9]+/ {
  
    portname = substr($0, match($0,/"[a-zA-Z0-9_]+"/), RLENGTH);
    pureportname = substr(portname,2,RLENGTH-2);
    if (structcoming == 1) {
      structcoming = 0 ;
      print "NET " pureportname >> ofile ;
      eno = 0 ;
    } else {
      id = substr($0, match($0,/[0-9]+/), RLENGTH);
      task = gettaskfromXXYY(pureportname);
      print task " " id " " pureportname >> ofile ;
      eno ++ ;
    }
}   

END {
  print "END " eno >> ofile ;
}

   
function gettaskfromXXYY(name) {
  return substr(name,1,index(name,"XX")-1);
}
