#---------------------------------------------------
#  genfc2
# 
#  gawk -f genfc2.awk summary.port
#
#  summary.port is produced by "collectports"
#  where summary.port  is the file contains all port name index 
#  the format of summary.port
#  TOTAL 2
#  NET a1
#  .......
#  END eno
#  NET a2
#  ......
#  END eno
#  OTHER
#  ............
#
#--------------------------------------------------------
BEGIN {
  tbno = 0 ;
  netno = 1 ;
  no = 0 ;  
  other = 0 ;
  ono = 0 ;
  edgeno = 0 ;
  tauno = 0 ;
}
/TOTAL/ {
  nets = $2 ; 
  print "% fc2 file generated from genfc2 " ;
  print "nets " nets+1 ;
  print "   hook\"main\" > 0" ;
  print "   struct \"" newname "\"" ;
  next ;
}
/NET/ { 
  netname = $2 ;
  netid[netno] = netname ;
  currentnetno = netno ;
  netno++ ;
  bno = 0 ;
  print "     net " currentnetno ;
  print "       structs 1 " ;
  print "           :0 " "\"" netname "\"" ;
  next ;
}
/END/ {
  print "       behavs " $2 ;
  for (i=0;i< bno; i++) {
    print "          :" behavid[i] " \"" behavname[i] "\"" ;
  }
  print "       struct 0" ;
  tail = bno-1 ;
  for (i=bno-2; i>= 0 ; i--) {
      tail = tail "+" i ;
  }
  print "       behav " tail ;
  print "       hook \"synch_vector\"" ;
  next ;
}
/OTHER/ { 
  other = 1 ;
  next ;
}
 
    
/./ {
  if (other==1) {
# if other==1 means we are passing the end of summary.port
    other_net[ono] = $1 ;
    other_offset[ono] = $2 ;
    other_portname[ono] = $3 ;
    ono ++ ;
  } else {
    
    if (gettaskfromXXYY($3) == netname) {
#   this port is a server port 
#   we save it in tb_array to be searched
      tb_portname[tbno] = $3 ;
      tb_offset[tbno] = $2 ;
      tb_netname[tbno] = $1 ;
      tb_called[tbno] = 0 ;
      tb_calledfromoutside[tbno] = 0;
      tbno ++ ;
    } else {
#   this port is a client port
#   it will connect to other port later
      from[no] = netname ;
      to[no] = $1 ;
      from_offset[no] = $2 ;
      portname[no] = $3 ;
      no ++ ;
    }
# save the content of net 
    behavid[bno] = $2 ;
    behavname[bno] = $3 ;
    bno ++ ;
  }
}
END {
  if (other ==0 ) {
    print "No OTHER section presented in summary.port ";
    exit 1 ;
  }
      
#  here we want to generate the net 0, which is the outer box
#  in atg 
  print "   net 0" ;
  print "     structs 1" ;
  print "        :0 \"" newname "\"" ;
#  now we compute how many ports should be imperatively exported 
  exportedno =  getExportedNo();
#  now we compute how many ports are forced to export because other tasks
#  outside the subsystem call the port
  otherexportno = getExportFromOtherNo();
  
  if (exportedno+otherexportno != 0) {
    print "     behavs " exportedno + otherexportno ;
    for (i=0;i<exportedno; i++) {
      print "        :" i " \""  exportbehav[i] "\"" ;
      finalexportbehav[i] = exportbehav[i] ;
    }
    for (i=0; i< otherexportno; i++) {
      print "        :" i+exportedno " \"" otherexportbehav[i] "\"" ;
      finalexportbehav[i+exportedno] = otherexportbehav[i] ;
    }
  }
  finalexportno = exportedno + otherexportno ;
    
# print structs  
  str = "     struct 0<" ;
  for (i=1;i<netno;i++) {
    if (i==1) 
  	str = str i ;
    else
        str = str "," i ;
  }
  print str ;
# print behav
  tail = finalexportno-1 ;
  for (i=finalexportno-2; i>= 0 ; i--) {
      tail = tail "+" i ;
  }
  if (finalexportno > 0) 
    print "       behav " tail ;
  print "       hook \"synch_vector\"" ;
  print "       vertice 1 " ;
  print "          vertex 0 " ;

  tauno = getTauEdgeNo();
  orphanno = getOrphanNo();
  
  
  print "          edges "  tauno + finalexportno+ orphanno ;

  # printtaus is to print those synchs occurs in subsystem
  printtaus(); 

  # rintexported is to print those synchs has server name
  # not included in the subsystem
  printexported();

  # There are some orphan ports (which does not have synchs
  # inside the subsystem ). These ports has tb_called[] == 0
  # there are two cases
  # case 1: there are some clients outside the subsystem call it
  #         so, we should output it.
  # case 2: there is no clients call it
  #         so, we should add a " behav tau < 2,*,*  -> 0

  printOtherExport();
  printOrphan();

  
}
function printOrphan() {
  for (nn=0;nn<tbno; nn++) {
    if (tb_called[nn]==0 && tb_calledfromoutside[nn] == 0) {
      from_netid = getnetid(tb_netname[nn]);
      localoffset = tb_offset[nn] ;
      str = "" ;
      for (j=1;j<netno; j++) {
    	if (j==1) {
    	  if (j == from_netid) 
    	    str = str localoffset ;
    	  else 
    	    str = str "*" ;
    	} else {
	  if (j == from_netid) 
    	    str = str "," localoffset ;
    	  else 
    	    str = str "," "*" ;
    	}
    } 
    print "edge " edgeno " behav tau < " str " -> 0 " ;
    edgeno ++ ;
    }
  }
}

function getOrphanNo() {
  tempno = 0 ;
  for (mm=0;mm<tbno;mm++) {
    if (tb_called[mm] == 0 && tb_calledfromoutside[mm] == 0) {
      tempno ++ ;
    }
  }
  return tempno ;
}
      

function printOtherExport() {
  for (c=0;c < tbno; c++) {
    if (tb_calledfromoutside[c] == -1) {
      from_netid = getnetid(tb_netname[c]) ;
      to_offset = getexportbehavoffset(tb_portname[c]);
      localoffset = tb_offset[c] ;

      str = "" ;
      for (j=1;j<netno; j++) {
    	if (j==1) {
    	  if (j == from_netid) 
    	    str = str localoffset ;
    	  else 
    	    str = str "*" ;
    	} else {
    	  if (j == from_netid) 
    	    str = str "," localoffset ;
    	  else 
    	    str = str "," "*" ;
    	}
      } 
      print "  edge " edgeno " behav " to_offset " < " str " -> 0 " ;
      edgeno ++ ;
    }
  }
}
function getExportFromOtherNo() {
  othercallno = 0 ;

  for (b=0; b< ono ; b++) {
    g = searchtable(other_portname[b]) ;
#    print "---searching  " other_portname[b] ;
    if (g != -1) {
# we got a match, there are other clients call the port
      tb_calledfromoutside[g] = -1 ;
    }
  }
  for (b=0;b< tbno; b++) {
    if (tb_calledfromoutside[b] == -1 ) {
      otherexportbehav[othercallno] = tb_portname[b] ;
      othercallno ++ ;
    }
  }
  return othercallno ;
}
    

function printexported() {
# In this function, we use client-side portname
# to determine the exported portname
# if a portname has task name not in the subsystem
# we export it

    for (i=0;i<exportedno;i++) {
      k = exportindex[i] ;
#   from[k] is the netname of source task
#   to[k] is the netname of destination task
#   from_offset[k] is the offset of source task
#   portname[k] is the portname of the edge

    from_netid = getnetid(from[k]);
    to_offset = getexportbehavoffset(portname[k]);
    str = "" ;
    for (j=1;j<netno; j++) {
    	if (j==1) {
    	  if (j == from_netid) 
    	    str = str from_offset[k] 
    	  else 
    	    str = str "*" ;
    	} else {
    	  if (j == from_netid) 
    	    str = str "," from_offset[k] ;
    	  else 
    	    str = str "," "*" ;
    	}
    } 
    print "edge " edgeno " behav  " to_offset " < " str " -> 0 " ;
    edgeno ++ ;
  }
  
}
function getexportbehavoffset(portname) {
   for (w=0;w< finalexportno; w++) {
     if (finalexportbehav[w] == portname) 
     	return w ;
  }
}
  
  
function printtaus() {  
# In this function, we use the client side portname
# to produce a paired tau transition
# tauindex[] is set by getTauEdgeNo();

#  print "tauno == " tauno ;
  for (i=0;i< tauno; i++) {
    k = tauindex[i] ;
#   from[k] is the netname of source task
#   to[k] is the netname of destination task
#   from_offset[k] is the offset of source task
#   portname[k] is the portname of the edge
#    print "=== to:" to[k] " from: " from[k] " port: " portname[k] ;
    to_offset = gettooffset(portname[k])   
    to_netid = getnetid(to[k]);
    from_netid = getnetid(from[k]);
    str = "" ;
    for (j=1;j<netno; j++) {
    	if (j==1) {
    	  if (j == to_netid) 
    	    str = str to_offset ;
    	  else if (j == from_netid) 
    	    str = str from_offset[k] ;
    	  else 
    	    str = str "*" ;
    	} else {
    	  if (j == to_netid) 
    	    str = str "," to_offset ;
    	  else if (j == from_netid) 
    	    str = str "," from_offset[k] ;
    	  else 
    	    str = str "," "*" ;
    	}
    } 
    print "edge " edgeno " behav tau < " str " -> 0 " ;
    edgeno ++ ;
  }
}

function getTauEdgeNo() {
# we use client port to get the edge
  tauno = 0 ;
  for (v=0;v<no;v++) {
    tbid = searchtable(portname[v]);
    if (tbid != -1) {
      # the client should be connected to a 
      # server port inside
      tb_called[tbid]++ ;
      tauindex[tauno] = v ;
      tauno ++ ;
    }
  }
  return tauno ;
}

function getnetid(netname)  {
     for (n=1;n<netno; n++) {
        if (netid[n] == netname) 
           return n ;
     }
     print "####### cannot find a netid, something wrong" ;
     return -1 ;
}     
function getExportedNo() {
  exportno = 0 ;
  for (i=0;i<no;i++) {
    if (searchtable(portname[i]) == -1) {
       # the portname is not in table
       # it is imperatively exported
      exportbehav[exportno] = portname[i] ;
      exportindex[exportno] = i ;
      exportno ++ ;
    }
  }    
  return exportno ;  
}
function searchtable(name) {
  for (kk=0;kk<tbno; kk++) {
    if (name == tb_portname[kk])
      return kk ;
  }
  return -1 ;
}
function gettooffset(name) {
  for (m=0;m<tbno;m++) {
    if (name == tb_portname[m])
      return tb_offset[m] ;
  }
}      
function gettaskfromXXYY(name) {
  return substr(name,1,index(name,"XX")-1);
}

     
