#---------------------------------------------------
#  genstruct
# 
#  gawk -f genstruct.awk -v systemname=namesummary.port
#  this awk script is used to generate a DOT file
#  The DOT file describe the structure of ports in summary.port
#
#  summary.port is produced by "collectports"
#  where summary.port  is the file contains all port name index 
#  the format of summary.port
#  TOTAL 2
#  NET a1
#  .......
#  END eno
#  NET a2
#  ......
#  END eno
#
#--------------------------------------------------------
BEGIN {
  tbno = 0 ;
  netno = 1 ;
  no = 0 ;  
}
/TOTAL/ {
  nets = $2 ; 
  # print "digraph \"" systemname "\" {" ; ;
   print "graph \"" systemname "\" {" ; ;
  next ;
}
/NET/ { 
  netname = $2 ;
  print "\"" netname "\" [ shape = box ]; " ;
  no = 0 ;
  next ;
}
/END/ {
  for (i=0;i<no; i++) {
#    print "\"" from[i] "\" -> \"" to[i] "\" [ label=\"" portname[i] "\" ];" ;
     print "\"" from[i] "\" -- \"" to[i] "\" ;"  ;
  }
  next ;
}
    
/./ {
# $1 is the task name of a port label
# $2 is the offset of the port
# $3 is the port label
  if (gettaskfromXXYY($3) == netname) {
#   this port is a server port 
#   we do not output it as an edge ;
    tb_portname[tbno] = $3 ;
    tb_netname[tbno] = $1 ;
    tbno ++ ;
  } else {
#   this port is a client port
#   we will draw an edge from client to server
    from[no] = netname ;
    to[no] = $1 ;
    portname[no] = $3 ;
    no ++ ;
  }
}
END {
  print "}" ;  
}


function gettaskfromXXYY(name) {
  return substr(name,1,index(name,"XX")-1);
}

     
